//+------------------------------------------------------------------+
//|                                                        ziggy.mq4 |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "No Copyright tetsuo 2011"
#property link      "http://www.al4a.com"

#property indicator_chart_window
#property indicator_buffers 3

#property indicator_color2 Lime
#property indicator_color3 Lime
//---- input parameters

extern double       ampiezza_perc=0.5;
extern int shift=10;
extern int left_shift=10;



double   ziggy[];
double parabola_sup[];
double parabola_inf[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
  
   SetIndexBuffer(0,ziggy);
   SetIndexStyle(0,DRAW_LINE,0,0);
   
   
   
   SetIndexBuffer(1,parabola_sup);
   SetIndexStyle(1,DRAW_LINE, 2, 2);
   SetIndexShift(1,shift);
   
   
   SetIndexBuffer(2,parabola_inf);
   SetIndexStyle(2,DRAW_LINE, 2, 2);
   SetIndexShift(2,shift);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   for(int i=0;i<Bars;i++) 
  {
   ObjectDelete("supporto"+i);
   ObjectDelete("resistenza"+i);
   ObjectDelete("punto"+i);
  }
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    counted_bars=IndicatorCounted();
//----
//---- Controllo dell'errore
   if(counted_bars < 0) 
   return(-1);
//---- 
   int trend[20000], numbar, shift_sup, shift_res, n_sup, n_res;
   numbar=Bars;//-counted_bars-1;
   ArrayInitialize(trend,1);
   for (int i=numbar; i>=0; i--)
   {    
      double ampiezza=ampiezza(i);  
      if (trend[i+1]==1)
	   {
	     if (High[i]>=High[i+1] && High[i]>ziggy[i+1]){ziggy[i]=High[i]; trend[i]=trend[i+1]; shift_res=0;}
        else if (High[i]>=High[i+1] && High[i]<=ziggy[i+1]) {ziggy[i]=ziggy[i+1]; trend[i]=trend[i+1]; shift_res++;}
        else if (High[i]<=High[i+1] && (ziggy[i+1]-ampiezza)<Low[i])	{ziggy[i]=ziggy[i+1]; trend[i]=trend[i+1]; shift_res++;}
        else if (High[i]<=High[i+1] && (ziggy[i+1]-ampiezza)>Low[i]) {ziggy[i]=Low[i]; trend[i]=-1; shift_res++; shift_sup=0;}
		}
		if (trend[i+1]==-1)
   	{
   	  if (Low[i]<=Low[i+1] && Low[i]<ziggy[i+1]) {ziggy[i]=Low[i]; trend[i]=trend[i+1]; shift_sup=0;}
        else if (Low[i]<=Low[i+1] && Low[i]>=ziggy[i+1]) {ziggy[i]=ziggy[i+1]; trend[i]=trend[i+1]; shift_sup++;}
        else if (Low[i]>=Low[i+1] && (ziggy[i+1]+ampiezza)>High[i]) {ziggy[i]=ziggy[i+1]; trend[i]=trend[i+1]; shift_sup++;}
        else if (Low[i]>=Low[i+1] && (ziggy[i+1]+ampiezza)<High[i]) {ziggy[i]=High[i]; trend[i]=1; shift_sup++; shift_res=0;}
      }
      if (trend[i]==trend[i+1])
      {
         ObjectSet("supporto"+n_sup,2,Time[i]);
         ObjectSet("resistenza"+n_res,2,Time[i]);
      }
      else if (trend[i]==-1 && trend[i+1]==1)
      {
         n_res++;
         //ObjectDelete("resistenza");
         ObjectCreate("resistenza"+n_res,2,0,Time[i+shift_res],ziggy[i+1],Time[i],ziggy[i+1]);
         ObjectSet("resistenza"+n_res,8,3);
         ObjectSet("resistenza"+n_res,6,Purple);
         ObjectSet("resistenza"+n_res,10,false);
         ObjectSet("supporto"+n_sup,2,Time[i]);
         
      }
      else if (trend[i]==1 && trend[i+1]==-1)
      {
         n_sup++;
         //ObjectDelete("supporto");
         ObjectCreate("supporto"+n_sup,2,0,Time[i+shift_sup],ziggy[i+1],Time[i],ziggy[i+1]);
         ObjectSet("supporto"+n_sup,8,3);
         ObjectSet("supporto"+n_sup,6,Green);
         ObjectSet("supporto"+n_sup,10,false);
         ObjectSet("resistenza"+n_res,2,Time[i]);
      }
   }
   punti_sup(n_res);
   punti_inf(n_sup);
   parabola_sup("punto3", "punto2", "punto1");
   parabola_inf("punto6", "punto5", "punto4");
//----
   return(0);
  }

//+------------------------------------------------------------------+
//| calcolo ampiezza intervallo                                      |
//+------------------------------------------------------------------+
double ampiezza(int i)
{
   double ampiezza;
   ampiezza=(ziggy[i+1]/100)*ampiezza_perc;
   return(ampiezza);
   
}

//+------------------------------------------------------------------+
//| punti superiori                                                  |
//+------------------------------------------------------------------+

void punti_sup(int n_res)
{
   
   
   for (int i=1; i<=3; i++)
   {
   ObjectCreate("punto"+i,22,0,ObjectGet("resistenza"+(n_res+1-i),0),ObjectGet("resistenza"+(n_res+1-i),1));
   ObjectSet("punto"+i,15,-1);
   }
   for(i=0;i<Bars;i++) 
  {
   
   ObjectDelete("resistenza"+i);
  
  }
}
 
//+------------------------------------------------------------------+
//| punti inferiori                                                  |
//+------------------------------------------------------------------+

void punti_inf(int n_sup)
{
   
   
   for (int i=1; i<=3; i++)
   {
   ObjectCreate("punto"+(i+3),22,0,ObjectGet("supporto"+(n_sup+1-i),0),ObjectGet("supporto"+(n_sup+1-i),1));
   ObjectSet("punto"+(i+3),15,-1);
   }
   for(i=0;i<Bars;i++) 
  {
   ObjectDelete("supporto"+i);
   
  
  }
}
 

 
//+------------------------------------------------------------------+
//| calcolo parabola superiore                                       |
//+------------------------------------------------------------------+

void parabola_sup(string punto1, string punto2, string punto3)
{

   double y1, y2, y3;
   int x1, x2, x3;
   
  
   x1=iBarShift(NULL,NULL,ObjectGet(punto1,0),false);
   x2=iBarShift(NULL,NULL,ObjectGet(punto2,0),false);
   x3=iBarShift(NULL,NULL,ObjectGet(punto3,0),false);
   
   y1=iHigh(NULL,NULL,x1);
   y2=iHigh(NULL,NULL,x2);
   y3=iHigh(NULL,NULL,x3);
   
   int start=x1+left_shift;
   int xx1=x1*x1;
   int xx2=x2*x2;
   int xx3=x3*x3;

   double D=(xx1*x2)+(x1*xx3)+(xx2*x3)-(x2*xx3)-(x1*xx2)-(xx1*x3);
   double DA=(y1*x2)+(x1*y3)+(y2*x3)-(x2*y3)-(x1*y2)-(y1*x3);
   double DB=(xx1*y2)+(y1*xx3)+(xx2*y3)-(y2*xx3)-(y1*xx2)-(xx1*y3);
   double DC=(xx1*x2*y3)+(x1*y2*xx3)+(y1*xx2*x3)-(y1*x2*xx3)-(y3*x1*xx2)-(y2*xx1*x3);

   double a=DA/D;
   double b=DB/D;
   double c=DC/D;
   
   for (int n=start;n>=0-shift;n--)
   {
      parabola_sup[n+shift]=(a*(n*n))+(b*n)+c;
   }
//----
   return;
}

//+------------------------------------------------------------------+
//| calcolo parabola inferiore                                       |
//+------------------------------------------------------------------+

void parabola_inf(string punto1, string punto2, string punto3)
{

   double y1, y2, y3;
   int x1, x2, x3;
   
  
   x1=iBarShift(NULL,NULL,ObjectGet(punto1,0),false);
   x2=iBarShift(NULL,NULL,ObjectGet(punto2,0),false);
   x3=iBarShift(NULL,NULL,ObjectGet(punto3,0),false);
   
   y1=iLow(NULL,NULL,x1);
   y2=iLow(NULL,NULL,x2);
   y3=iLow(NULL,NULL,x3);
   
   int start=x1+left_shift;
   int xx1=x1*x1;
   int xx2=x2*x2;
   int xx3=x3*x3;

   double D=(xx1*x2)+(x1*xx3)+(xx2*x3)-(x2*xx3)-(x1*xx2)-(xx1*x3);
   double DA=(y1*x2)+(x1*y3)+(y2*x3)-(x2*y3)-(x1*y2)-(y1*x3);
   double DB=(xx1*y2)+(y1*xx3)+(xx2*y3)-(y2*xx3)-(y1*xx2)-(xx1*y3);
   double DC=(xx1*x2*y3)+(x1*y2*xx3)+(y1*xx2*x3)-(y1*x2*xx3)-(y3*x1*xx2)-(y2*xx1*x3);

   double a=DA/D;
   double b=DB/D;
   double c=DC/D;
   
   for (int n=start;n>=0-shift;n--)
   {
      parabola_inf[n+shift]=(a*(n*n))+(b*n)+c;
   }
//----
   return;
}